




USE master
GO

IF NOT EXISTS(SELECT 1 FROM sys.databases WHERE name = N'SalesTest')
  CREATE DATABASE SalesTest ON PRIMARY 
  (NAME = N'SalesTest_data', 
   FILENAME = N'C:\Program Files\Microsoft SQL Server\MSSQL.1\MSSQL\Data\SalesTest.mdf', 
   SIZE = 25000KB, MAXSIZE = UNLIMITED, FILEGROWTH = 5%)
   LOG ON 
  (NAME = N'SalesTest_log', 
   FILENAME = N'C:\Program Files\Microsoft SQL Server\MSSQL.1\MSSQL\Data\SalesTest.ldf', 
   SIZE = 10000KB, MAXSIZE = UNLIMITED, FILEGROWTH = 10%)
GO

USE SalesTest
GO

IF EXISTS(SELECT * FROM sys.objects WHERE object_id = object_id(N'dbo.products') AND objectproperty(object_id, N'IsUserTable') = 1)
   DROP TABLE dbo.products
GO
CREATE TABLE dbo.products
(
    id        uniqueidentifier NOT NULL,
    reference nvarchar(20)     NOT NULL,
    name      nvarchar(80)     NOT NULL,
    CONSTRAINT PK_products PRIMARY KEY CLUSTERED (id),
    CONSTRAINT AK1_products UNIQUE (reference)
)
GO

IF EXISTS(SELECT * FROM sys.objects WHERE object_id = object_id(N'dbo.stores') AND objectproperty(object_id, N'IsUserTable') = 1)
   DROP TABLE dbo.stores
GO
CREATE TABLE dbo.stores
(
    id        uniqueidentifier NOT NULL,
    reference nvarchar(20)     NOT NULL,
    name      nvarchar(50)     NOT NULL,
    CONSTRAINT PK_stores PRIMARY KEY CLUSTERED (id),
    CONSTRAINT AK1_stores UNIQUE (reference)
)   
GO

IF EXISTS(SELECT * FROM sys.objects WHERE object_id = object_id(N'dbo.sales') AND objectproperty(object_id, N'IsUserTable') = 1)
   DROP TABLE dbo.sales
GO
CREATE TABLE dbo.sales
(
    product_id uniqueidentifier NOT NULL,
    store_id   uniqueidentifier NOT NULL,
    day        smalldatetime    NOT NULL,
    quantity   int              NOT NULL,
    price      money            NOT NULL,
    CONSTRAINT PK_sales PRIMARY KEY CLUSTERED (product_id, store_id, day),
    CONSTRAINT FK_sales_products FOREIGN KEY(product_id)
       REFERENCES products(id),
    CONSTRAINT FK_sales_stores FOREIGN KEY(store_id)
      REFERENCES stores(id)
)
GO

IF EXISTS(SELECT * FROM sys.objects WHERE object_id = object_id(N'dbo.sales_forecast') AND objectproperty(object_id, N'IsUserTable') = 1)
   DROP TABLE dbo.sales_forecast
GO
CREATE TABLE dbo.sales_forecast
(
    product_id uniqueidentifier NOT NULL,
    store_id   uniqueidentifier NOT NULL,
    week       smalldatetime    NOT NULL,
    quantity   int              NOT NULL,
    avg_price  money            NOT NULL,
    CONSTRAINT PK_sales_forecast PRIMARY KEY CLUSTERED (product_id, store_id, week),
    CONSTRAINT FK_sales_forecast_products FOREIGN KEY(product_id)
       REFERENCES products(id),
    CONSTRAINT FK_sales_forecast_stores FOREIGN KEY(store_id)
       REFERENCES stores(id)
)
GO
