









IF EXISTS (SELECT 1 FROM sys.objects WHERE object_id = OBJECT_ID(N'dbo.test_utils_time_to_zero') AND objectproperty(object_id, 'IsProcedure') = 1)
   DROP PROCEDURE dbo.test_utils_time_to_zero
GO
CREATE PROCEDURE dbo.test_utils_time_to_zero
AS
BEGIN
   SET NOCOUNT ON;

   DECLARE @date_with_time    datetime, 
           @date_without_time datetime;

   SELECT @date_with_time    = convert(datetime, '2008-01-02 11:22:33', 121),
          @date_without_time = convert(datetime, '2008-01-02 00:00:00', 121);

   DECLARE
    @Val18 datetime,
    @Val19 datetime,
    @ValStr18 nvarchar(255),
    @GivenValStr18 nvarchar(255);
SELECT
    @Val18 = (dbo.utils_time_to_zero(@date_with_time)),
    @Val19 = (@date_without_time);
IF (@Val18 IS NULL OR NOT(@Val18 = @Val19))
BEGIN
    SELECT @ValStr18 = convert(nvarchar(255), @Val18),
        @GivenValStr18 = convert(nvarchar(255), @Val19);
    raiserror('Error. Value is "%s". Expected "%s". Error truncate time', 16, 1, @ValStr18, @GivenValStr18);
END;
END;
GO



IF EXISTS (SELECT 1 FROM sys.objects WHERE object_id = OBJECT_ID(N'dbo.test_utils_get_weeks_list') AND objectproperty(object_id, 'IsProcedure') = 1)
   DROP PROCEDURE dbo.test_utils_get_weeks_list
GO
CREATE PROCEDURE dbo.test_utils_get_weeks_list
AS
BEGIN
   SET NOCOUNT ON;

   DECLARE @start_date   datetime, 
           @end_date     datetime, 
           @weeks_to_add int;

   SELECT @start_date   = getdate(), 
          @weeks_to_add = 7;
   SELECT @end_date = dateadd(ww, @weeks_to_add, @start_date);
   
   DECLARE
    @Val41 int,
    @Val42 int,
    @ValStr41 nvarchar(255),
    @GivenValStr41 nvarchar(255);
SELECT
    @Val41 = (SELECT count(*) FROM dbo.utils_get_weeks_list(@start_date, @end_date)),
    @Val42 = (@weeks_to_add + 1);
IF (@Val41 IS NULL OR NOT(@Val41 = @Val42))
BEGIN
    SELECT @ValStr41 = convert(nvarchar(255), @Val41),
        @GivenValStr41 = convert(nvarchar(255), @Val42);
    raiserror('Error. Value is "%s". Expected "%s". Expression: SELECT count(*) FROM dbo.utils_get_weeks_list(@start_date, @end_date)', 16, 1, @ValStr41, @GivenValStr41);
END;;

   DECLARE
    @Val46 int,
    @Val47 int,
    @ValStr46 nvarchar(255),
    @GivenValStr46 nvarchar(255);
SELECT
    @Val46 = (SELECT max(week_num) FROM dbo.utils_get_weeks_list(@start_date, @end_date)),
    @Val47 = (@weeks_to_add + 1);
IF (@Val46 IS NULL OR NOT(@Val46 = @Val47))
BEGIN
    SELECT @ValStr46 = convert(nvarchar(255), @Val46),
        @GivenValStr46 = convert(nvarchar(255), @Val47);
    raiserror('Error. Value is "%s". Expected "%s". Expression: SELECT max(week_num) FROM dbo.utils_get_weeks_list(@start_date, @end_date)', 16, 1, @ValStr46, @GivenValStr46);
END;;
END;
GO


IF EXISTS (SELECT 1 FROM sys.objects WHERE object_id = OBJECT_ID(N'dbo.test_utils_get_days_list') AND objectproperty(object_id, 'IsProcedure') = 1)
   DROP PROCEDURE dbo.test_utils_get_days_list
GO
CREATE PROCEDURE dbo.test_utils_get_days_list
AS
BEGIN
   SET NOCOUNT ON;

   DECLARE @start_date  datetime, 
           @end_date    datetime, 
           @days_to_add int;

   SELECT @start_date = convert(datetime, '2006-11-01', 21), 
          @end_date   = convert(datetime, '2007-02-01', 21);
   
   DECLARE
    @Val66 int,
    @Val67 int,
    @ValStr66 nvarchar(255),
    @GivenValStr66 nvarchar(255);
SELECT
    @Val66 = (SELECT count(*) FROM dbo.utils_get_days_list(@start_date, @end_date)),
    @Val67 = (datediff(dd, @start_date, @end_date) + 1);
IF (@Val66 IS NULL OR NOT(@Val66 = @Val67))
BEGIN
    SELECT @ValStr66 = convert(nvarchar(255), @Val66),
        @GivenValStr66 = convert(nvarchar(255), @Val67);
    raiserror('Error. Value is "%s". Expected "%s". Expression: SELECT count(*) FROM dbo.utils_get_days_list(@start_date, @end_date)', 16, 1, @ValStr66, @GivenValStr66);
END;;

   DECLARE
    @Val71 int,
    @Val72 int,
    @ValStr71 nvarchar(255),
    @GivenValStr71 nvarchar(255);
SELECT
    @Val71 = (SELECT max(day_num) FROM dbo.utils_get_days_list(@start_date, @end_date)),
    @Val72 = (datediff(dd, @start_date, @end_date) + 1);
IF (@Val71 IS NULL OR NOT(@Val71 = @Val72))
BEGIN
    SELECT @ValStr71 = convert(nvarchar(255), @Val71),
        @GivenValStr71 = convert(nvarchar(255), @Val72);
    raiserror('Error. Value is "%s". Expected "%s". Expression: SELECT max(day_num) FROM dbo.utils_get_days_list(@start_date, @end_date)', 16, 1, @ValStr71, @GivenValStr71);
END;;
END;
GO


IF EXISTS (SELECT 1 FROM sys.objects WHERE object_id = OBJECT_ID(N'dbo.test_utils_all') AND objectproperty(object_id, 'IsProcedure') = 1)
   DROP PROCEDURE dbo.test_utils_all
GO
CREATE PROCEDURE dbo.test_utils_all
AS
BEGIN
   SET NOCOUNT ON;
   EXEC dbo.test_utils_time_to_zero;
   EXEC dbo.test_utils_get_weeks_list;
   EXEC dbo.test_utils_get_days_list;
END;
GO








IF EXISTS(SELECT * FROM sys.views WHERE object_id = object_id(N'dbo.rand2'))
   DROP VIEW dbo.rand2
GO
CREATE VIEW dbo.rand2 AS 
  SELECT rand(abs(convert(int, convert(varbinary, newid())))) AS rand_value;
GO








IF EXISTS (SELECT 1 FROM sys.objects WHERE object_id = OBJECT_ID(N'dbo.test_sales_forecast_setup') AND objectproperty(object_id, 'IsProcedure') = 1)
   DROP PROCEDURE dbo.test_sales_forecast_setup
GO
CREATE PROCEDURE dbo.test_sales_forecast_setup
AS
BEGIN
   SET NOCOUNT ON;

   /* Fill test data */
   INSERT INTO products(id, reference, name)
   SELECT newid(), 'TEST#prod1', 'Product 1'
   UNION
   SELECT newid(), 'TEST#prod2', 'Product 2'
   UNION
   SELECT newid(), 'TEST#prod3', 'Product 3'


   INSERT INTO stores(id, reference, name)
   SELECT newid(), 'TEST#store1', 'Store1 Msk'
   UNION
   SELECT newid(), 'TEST#store2', 'Store2 SPb';


   INSERT INTO sales (store_id, product_id, [day], quantity, price)
   SELECT s.id, p.id, d.start_date,
          convert(int, ((SELECT rand_value FROM rand2) * 1000)),
          (SELECT rand_value FROM rand2) * 100.00
      FROM products p
           CROSS JOIN
           stores s
           CROSS JOIN
           dbo.utils_get_days_list(convert(datetime, '2007-01-08', 21), convert(datetime, '2007-02-19', 21)) d
      WHERE p.reference LIKE 'TEST#%' AND
            s.reference LIKE 'TEST#%'


   DECLARE
    @Val50 int,
    @Val51 int,
    @ValStr50 nvarchar(255),
    @GivenValStr50 nvarchar(255);
SELECT
    @Val50 = (SELECT count(*)
          FROM sales 
               INNER JOIN stores ON sales.store_id = stores.id
               INNER JOIN products ON sales.product_id = products.id
          WHERE stores.reference LIKE 'TEST#%' AND 
                products.reference LIKE 'TEST#%' AND 
                day BETWEEN convert(datetime, '2007-01-08', 21) AND convert(datetime, '2007-02-19', 21)
      ),
    @Val51 = (0);
IF (@Val50 IS NULL OR NOT(@Val50 > @Val51))
BEGIN
    SELECT @ValStr50 = convert(nvarchar(255), @Val50),
        @GivenValStr50 = convert(nvarchar(255), @Val51);
    raiserror('Error. Value "%s" is less or equals than "%s". Sales table has no data', 16, 1, @ValStr50, @GivenValStr50);
END;;

END;
GO


IF EXISTS (SELECT 1 FROM sys.objects WHERE object_id = OBJECT_ID(N'dbo.test_sales_forecast_teardown') AND objectproperty(object_id, 'IsProcedure') = 1)
   DROP PROCEDURE dbo.test_sales_forecast_teardown
GO
CREATE PROCEDURE dbo.test_sales_forecast_teardown
AS
BEGIN
   SET NOCOUNT ON;

   DELETE FROM sales_forecast
      WHERE product_id IN (SELECT id FROM products WHERE reference LIKE 'TEST#%');

   DELETE FROM sales 
      WHERE product_id IN (SELECT id FROM products WHERE reference LIKE 'TEST#%');

   DELETE FROM products WHERE reference LIKE 'TEST#%';
   DELETE FROM stores WHERE reference LIKE 'TEST#%';
END;
GO


IF EXISTS (SELECT 1 FROM sys.objects WHERE object_id = OBJECT_ID(N'dbo.test_sales_forecast_init') AND objectproperty(object_id, 'IsProcedure') = 1)
   DROP PROCEDURE dbo.test_sales_forecast_init
GO
CREATE PROCEDURE dbo.test_sales_forecast_init
AS
BEGIN
   SET NOCOUNT ON;

   DECLARE @first_week     datetime,
           @last_week      datetime,
           @first_week_ref datetime;
   SELECT 
      @first_week     = convert(datetime, '2008-01-07', 21),
      @last_week      = convert(datetime, '2008-02-18', 21),
      @first_week_ref = convert(datetime, '2007-01-08', 21);


   EXEC dbo.sales_forecast_init
      @first_week     = @first_week,
      @last_week      = @last_week,
      @first_week_ref = @first_week_ref;


   DECLARE
    @Val104 int,
    @Val105 int,
    @ValStr104 nvarchar(255),
    @GivenValStr104 nvarchar(255);
SELECT
    @Val104 = (SELECT count(*)
          FROM sales_forecast
               INNER JOIN stores ON sales_forecast.store_id = stores.id
               INNER JOIN products ON sales_forecast.product_id = products.id
          WHERE stores.reference LIKE 'TEST#%' AND 
                products.reference LIKE 'TEST#%' AND 
                week BETWEEN @first_week AND @last_week
      ),
    @Val105 = (0);
IF (@Val104 IS NULL OR NOT(@Val104 > @Val105))
BEGIN
    SELECT @ValStr104 = convert(nvarchar(255), @Val104),
        @GivenValStr104 = convert(nvarchar(255), @Val105);
    raiserror('Error. Value "%s" is less or equals than "%s". Sales forecasts has no data', 16, 1, @ValStr104, @GivenValStr104);
END;;

   /* Check calculated data on random week */
   DECLARE @store_id      uniqueidentifier,
           @product_id    uniqueidentifier,
           @week_to_check datetime,
           @ref_week      datetime;

   SELECT @store_id = id FROM stores WHERE reference = 'TEST#store1';
   SELECT @product_id = id FROM products WHERE reference = 'TEST#prod2';
   SELECT @week_to_check = 
      dateadd(ww, 
              datediff(ww, @first_week, @last_week) * (SELECT rand_value FROM rand2), 
              @first_week);
   SELECT @ref_week = dateadd(ww, datediff(ww, @first_week, @week_to_check), @first_week_ref);

   DECLARE
    @Val131 int,
    @Val132 int,
    @ValStr131 nvarchar(255),
    @GivenValStr131 nvarchar(255);
SELECT
    @Val131 = (SELECT quantity
          FROM sales_forecast
          WHERE store_id = @store_id AND 
                product_id = @product_id AND
                week = @week_to_check
      ),
    @Val132 = (SELECT SUM(quantity) 
          FROM sales 
          WHERE store_id = @store_id AND 
                product_id = @product_id AND
                [day] BETWEEN @ref_week AND dateadd(ww, 1, @ref_week)
      );
IF (@Val131 IS NULL OR NOT(@Val131 = @Val132))
BEGIN
    SELECT @ValStr131 = convert(nvarchar(255), @Val131),
        @GivenValStr131 = convert(nvarchar(255), @Val132);
    raiserror('Error. Value is "%s". Expected "%s". Invalid quantity', 16, 1, @ValStr131, @GivenValStr131);
END;;

   DECLARE
    @Val147 int,
    @Val148 int,
    @ValStr147 nvarchar(255),
    @GivenValStr147 nvarchar(255);
SELECT
    @Val147 = (SELECT avg_price
          FROM sales_forecast
          WHERE store_id = @store_id AND 
                product_id = @product_id AND
                week = @week_to_check
      ),
    @Val148 = (SELECT AVG(price) 
          FROM sales 
          WHERE store_id = @store_id AND 
                product_id = @product_id AND
                [day] BETWEEN @ref_week AND dateadd(ww, 1, @ref_week)
      );
IF (@Val147 IS NULL OR NOT(@Val147 = @Val148))
BEGIN
    SELECT @ValStr147 = convert(nvarchar(255), @Val147),
        @GivenValStr147 = convert(nvarchar(255), @Val148);
    raiserror('Error. Value is "%s". Expected "%s". Invalid average price', 16, 1, @ValStr147, @GivenValStr147);
END;;

END;
GO


IF EXISTS (SELECT 1 FROM sys.objects WHERE object_id = OBJECT_ID(N'dbo.test_sales_forecast_all') AND objectproperty(object_id, 'IsProcedure') = 1)
   DROP PROCEDURE dbo.test_sales_forecast_all
GO
CREATE PROCEDURE dbo.test_sales_forecast_all
AS
BEGIN
   SET NOCOUNT ON;
   EXEC dbo.test_sales_forecast_setup;
   EXEC dbo.test_sales_forecast_init;
   EXEC dbo.test_sales_forecast_teardown;
END;
GO
