









IF EXISTS (SELECT 1 FROM sys.objects WHERE object_id = OBJECT_ID(N'dbo.test_utils_time_to_zero') AND objectproperty(object_id, 'IsProcedure') = 1)
   DROP PROCEDURE dbo.test_utils_time_to_zero
GO
CREATE PROCEDURE dbo.test_utils_time_to_zero
AS
BEGIN
   SET NOCOUNT ON;

   DECLARE @date_with_time    datetime, 
           @date_without_time datetime;

   SELECT @date_with_time    = convert(datetime, '2008-01-02 11:22:33', 121),
          @date_without_time = convert(datetime, '2008-01-02 00:00:00', 121);

   DECLARE
    @Val18 datetime,
    @Val19 datetime,
    @ValStr18 nvarchar(255),
    @GivenValStr18 nvarchar(255);
SELECT
    @Val18 = (dbo.utils_time_to_zero(@date_with_time)),
    @Val19 = (@date_without_time);
IF (@Val18 IS NULL OR NOT(@Val18 = @Val19))
BEGIN
    SELECT @ValStr18 = convert(nvarchar(255), @Val18),
        @GivenValStr18 = convert(nvarchar(255), @Val19);
    raiserror('Error. Value is "%s". Expected "%s". Error truncate time', 16, 1, @ValStr18, @GivenValStr18);
END;
END;
GO



IF EXISTS (SELECT 1 FROM sys.objects WHERE object_id = OBJECT_ID(N'dbo.test_utils_get_weeks_list') AND objectproperty(object_id, 'IsProcedure') = 1)
   DROP PROCEDURE dbo.test_utils_get_weeks_list
GO
CREATE PROCEDURE dbo.test_utils_get_weeks_list
AS
BEGIN
   SET NOCOUNT ON;

   DECLARE @start_date   datetime, 
           @end_date     datetime, 
           @weeks_to_add int;

   SELECT @start_date   = getdate(), 
          @weeks_to_add = 7;
   SELECT @end_date = dateadd(ww, @weeks_to_add, @start_date);
   
   DECLARE
    @Val41 int,
    @Val42 int,
    @ValStr41 nvarchar(255),
    @GivenValStr41 nvarchar(255);
SELECT
    @Val41 = (SELECT count(*) FROM dbo.utils_get_weeks_list(@start_date, @end_date)),
    @Val42 = (@weeks_to_add + 1);
IF (@Val41 IS NULL OR NOT(@Val41 = @Val42))
BEGIN
    SELECT @ValStr41 = convert(nvarchar(255), @Val41),
        @GivenValStr41 = convert(nvarchar(255), @Val42);
    raiserror('Error. Value is "%s". Expected "%s". Expression: SELECT count(*) FROM dbo.utils_get_weeks_list(@start_date, @end_date)', 16, 1, @ValStr41, @GivenValStr41);
END;;

   DECLARE
    @Val46 int,
    @Val47 int,
    @ValStr46 nvarchar(255),
    @GivenValStr46 nvarchar(255);
SELECT
    @Val46 = (SELECT max(week_num) FROM dbo.utils_get_weeks_list(@start_date, @end_date)),
    @Val47 = (@weeks_to_add + 1);
IF (@Val46 IS NULL OR NOT(@Val46 = @Val47))
BEGIN
    SELECT @ValStr46 = convert(nvarchar(255), @Val46),
        @GivenValStr46 = convert(nvarchar(255), @Val47);
    raiserror('Error. Value is "%s". Expected "%s". Expression: SELECT max(week_num) FROM dbo.utils_get_weeks_list(@start_date, @end_date)', 16, 1, @ValStr46, @GivenValStr46);
END;;
END;
GO


IF EXISTS (SELECT 1 FROM sys.objects WHERE object_id = OBJECT_ID(N'dbo.test_utils_get_days_list') AND objectproperty(object_id, 'IsProcedure') = 1)
   DROP PROCEDURE dbo.test_utils_get_days_list
GO
CREATE PROCEDURE dbo.test_utils_get_days_list
AS
BEGIN
   SET NOCOUNT ON;

   DECLARE @start_date  datetime, 
           @end_date    datetime, 
           @days_to_add int;

   SELECT @start_date = convert(datetime, '2006-11-01', 21), 
          @end_date   = convert(datetime, '2007-02-01', 21);
   
   DECLARE
    @Val66 int,
    @Val67 int,
    @ValStr66 nvarchar(255),
    @GivenValStr66 nvarchar(255);
SELECT
    @Val66 = (SELECT count(*) FROM dbo.utils_get_days_list(@start_date, @end_date)),
    @Val67 = (datediff(dd, @start_date, @end_date) + 1);
IF (@Val66 IS NULL OR NOT(@Val66 = @Val67))
BEGIN
    SELECT @ValStr66 = convert(nvarchar(255), @Val66),
        @GivenValStr66 = convert(nvarchar(255), @Val67);
    raiserror('Error. Value is "%s". Expected "%s". Expression: SELECT count(*) FROM dbo.utils_get_days_list(@start_date, @end_date)', 16, 1, @ValStr66, @GivenValStr66);
END;;

   DECLARE
    @Val71 int,
    @Val72 int,
    @ValStr71 nvarchar(255),
    @GivenValStr71 nvarchar(255);
SELECT
    @Val71 = (SELECT max(day_num) FROM dbo.utils_get_days_list(@start_date, @end_date)),
    @Val72 = (datediff(dd, @start_date, @end_date) + 1);
IF (@Val71 IS NULL OR NOT(@Val71 = @Val72))
BEGIN
    SELECT @ValStr71 = convert(nvarchar(255), @Val71),
        @GivenValStr71 = convert(nvarchar(255), @Val72);
    raiserror('Error. Value is "%s". Expected "%s". Expression: SELECT max(day_num) FROM dbo.utils_get_days_list(@start_date, @end_date)', 16, 1, @ValStr71, @GivenValStr71);
END;;
END;
GO


IF EXISTS (SELECT 1 FROM sys.objects WHERE object_id = OBJECT_ID(N'dbo.test_utils_all') AND objectproperty(object_id, 'IsProcedure') = 1)
   DROP PROCEDURE dbo.test_utils_all
GO
CREATE PROCEDURE dbo.test_utils_all
AS
BEGIN
   SET NOCOUNT ON;
   EXEC dbo.test_utils_time_to_zero;
   EXEC dbo.test_utils_get_weeks_list;
   EXEC dbo.test_utils_get_days_list;
END;
GO